/*
* Code by Bodysoulspirit. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
					  "title" : "Reinterpret 3D Object",
					  "keywords" : ["Elements Assembly Method", "Line Strip", "Triangle Strip", "Triangle Fan"],
						"description" : "Changes the Element Assembly Method of a Scene Object. Still experimental, the lightning is not calculated properly, usually need to inverse lightning positions. Inspired by Smokris node for Vuo 1",
					  "version" : "1.0.0",
				  });

void nodeEvent
(
		VuoInputData(VuoSceneObject) object,
		VuoInputData(VuoTransform) transform,
		VuoInputData(VuoShader) shader,
		VuoInputData(VuoInteger, { "menuItems":[
			{"value":0, "name":"Points"},
			{"value":1, "name":"Individual Lines"},
			{"value":2, "name":"Lines Strip"},
			{"value":3, "name":"Individual Triangles"},
			{"value":4, "name":"Triangles Strip"},
			{"value":5, "name":"Triangles Fan"},
		], "default":0} ) assemblyMethod,
		VuoInputData(VuoReal, {"default":0.01}) size,
		VuoOutputData(VuoSceneObject) newObject
)
{
		VuoMesh_ElementAssemblyMethod method =
			assemblyMethod == 0 ? VuoMesh_Points :
			assemblyMethod == 1 ? VuoMesh_IndividualLines :
			assemblyMethod == 2 ? VuoMesh_LineStrip :
			assemblyMethod == 3 ? VuoMesh_IndividualTriangles :
			assemblyMethod == 4 ? VuoMesh_TriangleStrip : VuoMesh_TriangleFan;

		unsigned int vertexCount = 0;
		float *positions = 0;
		VuoMesh oldMesh = VuoMesh_copyShallow(VuoSceneObject_getMesh(object));
		VuoMesh_getCPUBuffers(oldMesh, &vertexCount, &positions, NULL, NULL, NULL, 0, NULL);
		VuoMesh newMesh = VuoMesh_makeFromCPUBuffers(vertexCount, positions, NULL, NULL, NULL, 0, NULL, method);
		VuoMesh_setPrimitiveSize(newMesh, size);
		//VuoMesh_setFaceCulling(newMesh, cull);
		*newObject = VuoSceneObject_makeMesh(newMesh, shader, transform);
}
